//---------------------------------------------------------------------------

#ifndef JobH
#define JobH
//---------------------------------------------------------------------------

#include <Classes.hpp>
#include <SysUtils.hpp>
#include <vector>

#include "ResizeCfg.h"

struct SourceFile;

class Job
{
public:
	enum Type
	{
		UNPACK = 0,
		RENDER_PDF,
		CONVERT,
		PACK
	} type;
	AnsiString fileName;
	ResizeCfg resizeCfg;
	AnsiString sImExtraParamsBeforeResize;
	AnsiString sImExtraParams;
	AnsiString sOutputExtension;

	static AnsiString GetTmpDir(AnsiString fileName);
	void Execute(bool *abort, int priority);

	static void SetTmpPath(AnsiString dir);
	static void SetOutPath(AnsiString dir);
	static void SetUseSourceDirectoryForOutput(bool val);
	static void SetGsPath(AnsiString gsExecutable);
	static void SetGsParams(AnsiString params);
	static void SetGsFilePattern(AnsiString pattern);

	SourceFile *file;
	Job(SourceFile *file):
		file(file)
	{

	}

private:
	void Unpack(void);
	void RenderPdf(void);
	void Convert(void);
	void ScanDir(AnsiString path);
	void ConvertFile(AnsiString name, int width, int height);
	void Pack(void);

	void ProcessSource(AnsiString dir, AnsiString cmdline);

	bool* abort;
	int priority;
};

#endif
